//
//  XmlRpcFilterServiceProvider.m
//  XmlRpcFilterService
//
//  Created by Les Orchard on Sun Mar 10 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "XmlRpcFilterServiceProvider.h"
#import <Foundation/Foundation.h>
#import <EDInternet/EDInternet.h>
#import <XMLRPC/XMLRPC.h>

@implementation XmlRpcFilterServiceProvider

- (void)doFilterService:(NSPasteboard *)pboard
			   userData:(NSString *)data
				  error:(NSString **)error
{
    NSString *serverURL  = @"http://www.decafbad.com/twiki/bin/twiki_xmlrpc.cgi";
	NSString *methodName = @"filter.filterData";
	NSString *filterName = @"wiki";

    XRConnection *connection;
    id result;
    NSArray *types;

	NSString *textIn;
	NSString *textOut;

    types = [pboard types];

    if (![types containsObject:NSStringPboardType] ||
		!(textIn = [pboard stringForType:NSStringPboardType])) {
        *error = NSLocalizedString(@"Error: Pasteboard doesn't contain a string.",
								   @"Pasteboard couldn't give string.");
        return;
    }

	NSLog(@"FILTER TEXT IN: %@", textIn);

	connection = [XRConnection connectionWithURL:[NSURL URLWithString:serverURL]];
	result = [connection performRemoteMethod:methodName withObjects:[NSArray arrayWithObjects:filterName, textIn, nil]];
	textOut = [NSString stringWithCString:[result bytes] length:[result length]];

    if (!textOut) {
        *error = NSLocalizedString(@"Error: Couldn't capitalize string %@.",
								   @"Couldn't perform service operation.");
        return;
    }

	NSLog(@"FILTER TEXT OUT: %@", textOut);

    /* We now return the capitalized string... */
    types = [NSArray arrayWithObject:NSStringPboardType];
    [pboard declareTypes:types owner:nil];
    [pboard setString:textOut forType:NSStringPboardType];

    return;	
}

@end
